---
title: range
slug: Web/CSS/@counter-style/range
tags:
  - '@counter-style'
  - At-rule descriptor
  - CSS
  - CSS Counter Styles
  - CSS Descriptor
  - Reference
---
<div>{{cssref}}</div>

<p><span class="seoSummary">When defining custom counter styles, the <strong><code>range</code></strong> descriptor lets the author specify a range of counter values over which the style is applied. If a counter value is outside the specified range, then the fallback style will be used to construct the representation of that marker.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css notranslate">/* Keyword value */
range: auto;

/* Range values */
range: 2 5;
range: infinite 10;
range: 6 infinite;
range: infinite infinite;

/* Multiple range values */
range: 2 5, 8 10;
range: infinite 6, 10 infinite;
</pre>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>auto</code></dt>
 <dd>The range depends on the counter system:
 <ul>
  <li>For cyclic, numeric, and fixed systems, the range is negative infinity to positive infinity.</li>
  <li>For alphabetic and symbolic systems, the range is 1 to positive infinity.</li>
  <li>For additive systems, the range is 0 to positive infinity.</li>
  <li>For extends systems, the range is whatever auto would produce for the extended system; if extending a complex predefined style (§7 Complex Predefined Counter Styles), the range is the style’s defined range.</li>
 </ul>
 </dd>
 <dt><code>[ [ | infinite ]{2} ]#</code></dt>
 <dd>Defines a comma-separated list of ranges. For each individual range, the first value is the lower bound and the second value is the upper bound. A range is inclusive, that means it always contains both, the lower and upper bound numbers. If infinite is used as the first value in a range, it represents negative infinity; if it is used as the second value, it represents positive infinity. The range of the counter style is the union of all the ranges defined in the list.<br>
 If the lower bound of any range is higher than the upper bound, the entire descriptor is invalid and will be ignored.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>The value of the range descriptor can be either auto or a comma separated list of lower and upper bounds specified as integers.</p>

<p>If value is auto, then for cyclic, numeric, and fixed system, the range will be from negative infinity to positive infinity. For alphabetic and symbolic systems, range will be from 1 to positive infinity. For additive systems, auto will result in the range 0 to positive infinity. For extends systems, the range is whatever auto will produce for the extended system.</p>

<p>When range is specified as integers, the value <code>infinite</code> can be used to denote infinity. If <em>infinite</em> is specified as the first value in a range, then it is interpreted as negative infinity. If used as upper bound, it is taken as positive infinity.</p>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_counter_style_over_a_range">Setting counter style over a range</h3>

<pre class="brush: html notranslate">&lt;ul class="list"&gt;
  &lt;li&gt;One&lt;/li&gt;
  &lt;li&gt;Two&lt;/li&gt;
  &lt;li&gt;Three&lt;/li&gt;
  &lt;li&gt;Four&lt;/li&gt;
  &lt;li&gt;Five&lt;/li&gt;
  &lt;li&gt;Six&lt;/li&gt;
  &lt;li&gt;Seven&lt;/li&gt;
  &lt;li&gt;Eight&lt;/li&gt;
  &lt;li&gt;Nine&lt;/li&gt;
  &lt;li&gt;Ten&lt;/li&gt;
&lt;/ul&gt;</pre>

<pre class="brush: css notranslate">@counter-style range-multi-example {
  system: cyclic;
  symbols: "\25A0" "\25A1";
  range: 2 4, 7 9;
}

.list {
  list-style: range-multi-example;
}</pre>

<p>The above list will display as follows:</p>

<p>   1. One<br>
   □. Two<br>
   ■. Three<br>
   □. Four<br>
    5. Five<br>
    6. Six<br>
   ■. Seven<br>
   □. Eight<br>
   ■. Nine<br>
   10. Ten</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS3 Counter Styles", "#counter-style-range", "range")}}</td>
   <td>{{Spec2('CSS3 Counter Styles')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.at-rules.counter-style.range")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{Cssxref("list-style")}}, {{Cssxref("list-style-image")}}, {{Cssxref("list-style-position")}}</li>
 <li>{{cssxref("symbols", "symbols()")}}, the functional notation creating anonymous counter styles.</li>
</ul>
